#!/usr/local/bin/perl
#
# A bit of an evil hack but it post processes the file ../MINFO which
# is generated by `make files` in the top directory.
# This script outputs one mega magefile that has no shell stuff or any
# funny make stuff
#


$infile="MINFO";

%link_ms=(
	"SSLOBJ","\$(SSLOBJ)",
	"RSAGLUEOBJ","\$(RSAGLUEOBJ)",
	"CRYPTOOBJ","\$(CRYPTOOBJ)",
	"E_OBJ","\$(E_OBJ)",
	);
%link_unix=(
	"SSLOBJ",	'$(SSLOBJ)',
	"RSAGLUEOBJ",	'$(RSAGLUEOBJ)',
	"CRYPTOOBJ",	'$(CRYPTOOBJ)',
	"E_OBJ",	'$(E_OBJ)',
	);

%ops=(
	"VC-MSDOS","Microsoft Visual C++ 1.51 - MSDOS",
	"VC-WIN32","Microsoft Visual C++ 4.[01] - Windows NT 3.51",
	"BC-WIN32","Borland C++ 4.5 - Windows NT 3.51",
	"solaris","Borland C++ 4.5 - Windows NT 3.51",
	"FreeBSD","FreeBSD distribution",
	"default","cc under unix",
	);

$type="";
foreach (@ARGV)
	{
	if (/^no-rc$/)		{ $no_rc2=$no_rc4=1; }
	elsif (/^no-rc2$/)	{ $no_rc2=1; }
	elsif (/^no-rc4$/)	{ $no_rc4=1; }
	elsif (/^no-idea$/)	{ $no_idea=1; }
	elsif (/^no-des$/)	{ $no_des=1; }
	elsif (/^no-md$/)	{ $no_md2=$no_md5=1; }
	elsif (/^no-md2$/)  	{ $no_md2=1; }
	elsif (/^no-md5$/)	{ $no_md5=1; }
	elsif (/^no-sock$/)	{ $no_sock=1; }
	elsif (/^rsaref$/)	{ $rsaref=1; }
	elsif (/^gcc$/)		{ $gcc=1; }
	else
		{
		if (!defined($ops{$_}))
			{
			print STDERR "usage: perl mk1mf.pl [system] [options]\n";
			print STDERR "\nwhere [system] can be one of the following\n";
			foreach $i (sort keys %ops)
				{ printf STDERR "\t%-7s\t%s\n",$i,$ops{$i}; }
			print STDERR "\nand [options] can be one of\n";
			print STDERR "\tno-rc   no-rc2  no-rc4\n";
			print STDERR "\tno-idea no-des  \n";
			print STDERR "\tno-md   no-md2  no-md5\n";
			print STDERR "\tno-sock\n";
			print STDERR "\trsaref  build to require RSAref\n";
			print STDERR "\tgcc     build using gcc\n";
			exit(1);
			}
		$type=$_;
		}
	}

if ($type eq "VC-MSDOS") { $ms=1; $vc=1; $msdos=1; $no_sock=1; }
if ($type eq "VC-WIN32") { $ms=1; $vc=1; $w32=1; $no_sock=1; }
if ($type eq "BC-WIN32") { $ms=1; $bc=1; $w32=1; $no_sock=1;}
if ($type eq "FreeBSD") { $no_md2=1; $no_md5=1; $no_des=1; }

$tmp_dir='tmp';

$cflags='-DTERMIO ';
if ($gcc)
	{
	$cc='gcc';
	$cflags.='-O3 -fomit-frame-pointer';
	}
else
	{
	$cc='cc';
	$cflags.='-O';
	}

$ex_libs="";
$o='/';
$mklib='ar r';
$ranlib='util/ranlib.sh';
$obj='.o';
$plib='lib';
$libp=".a";
$exep='';
$lfile='';
$ofile='-o ';	# Keep the space 
$efile='-o ';	# Keep the space 
$cp='/bin/cp';
$rm='/bin/rm -f';
$asm='as ';
$bn_mulw_obj="";
$bn_mulw_src="";
%link=%link_unix;

if ($ms)
	{
	%link=%link_ms;
	$ranlib='';
	$cp='copy';
	$rm='del';
	$o='\\';
	$obj='.obj';
	$plib="";
	$libp=".lib";
	$exep='.exe';
	$mklib='lib';
	$lfile='/out:';
	if ($vc)
		{
		$cc='cl';
		$ofile="/Fo";
		$efile="/Fe";
		$cflags='/Ox /nologo';
		if ($msdos)
			{
			$lfile='';
			$cflags.=' /AL /F 8000 /Gt4096';
			$ex_libs='/SEG:512';
			}
		}
	elsif ($bc)
		{
		$cc=($w32)?'bcc32':'bcc';
		$ofile="-o";
		$efile="-e";
		$cflags='-O';
		}
	$cflags.=" -DMSDOS" if $msdos;
	if ($w32)
		{
		$bn_mulw_obj='crypto\bn\asm\x86-32.obj';
		$bn_mulw_src='crypto\bn\asm\x86-32.asm';
		$cflags.=" -DWIN32";
		}
	if ($w16)
		{
		$bn_mulw_obj='crypto\bn\asm\x86-16.obj';
		$bn_mulw_src='crypto\bn\asm\x86-16.asm';
		$cflags.=" -DWIN16";
		}
	}

if ($type eq "FreeBSD")
	{
	$cflags='-O2';
	$ex_libs='-lmd -ldes';
	}

$cflags.=" -DNO_IDEA" if $no_idea;
$cflags.=" -DNO_RC2"  if $no_rc2;
$cflags.=" -DNO_RC4"  if $no_rc4;
$cflags.=" -DNO_MD2"  if $no_md2;
$cflags.=" -DNO_MD5"  if $no_md5;
$cflags.=" -DNO_DES"  if $no_des;
$cflags.=" -DNO_SOCK" if $no_sock;
$cflags.=" -DRSAref"  if $rsaref;

$bbn_mulw=&bname($bn_mulw);
$defs= <<"EOF";
# This makefile has been automatically generated from the SSLeay distribution.
# This single makefile will build the complete SSLeay distribution and
# by default leave the 'intertesting' output files in .${o}out and the stuff
# that needs deleting in .${o}tmp.
# The file was generated by running 'make makefile.one', which
# does a 'make files', which writes all the environment variables from all
# the makefiles to the file call MINFO.  This file is used by
# util${o}mk1mf.pl to generate makefile.one.
# The 'makefile per directory' system suites me when developing this
# library and also so I can 'distribute' indervidual library sections.
# The one monster makefile better suits building in non-unix
# environments.

# Set your compiler options
CC=${cc}
CFLAG=$cflags
EX_LIBS=$ex_libs
BN_MULW_OBJ=$bn_mulw_obj
BN_MULW_SRC=$bn_mulw_src

# The output directory for everything intersting
OUT=out
# The output directory for all the temporary muck
TMP_D=$tmp_dir

CP=$cp
RM=$rm
RANLIB=$ranlib
MKDIR=mkdir
MKLIB=$mklib
ASM=$asm

######################################################
# You should not need to touch anything below this point
######################################################

ASM_PATH=crypto${o}bn${o}asm
E_EXE=ssleay
L_LIBS= \$(O_SSL) \$(O_CRYPTO) \$(EX_LIBS)
#L_LIBS= \$(O_SSL) \$(O_RSAGLUE) \$(O_CRYPTO) -lrsaref \$(EX_LIBS)

SSL=ssl
CRYPTO=crypto
RSAGLUE=RSAglue

# BIN_D  - Binary output directory
# TEST_D - Binary test file output directory
# LIB_D  - library output directory
# INC_D  - include directory
BIN_D=\$(OUT)
TEST_D=\$(OUT)
LIB_D=\$(OUT)
INC_D=\$(OUT)

# INCL_D - local library directory
# OBJ_D  - temp object file directory
OBJ_D=\$(TMP_D)
INCL_D=\$(TMP_D)

######################################################
# Don't touch anything below this point
######################################################

N_SSL=${plib}\$(SSL)$libp
N_CRYPTO=${plib}\$(CRYPTO)$libp
N_RSAGLUE=${plib}\$(RSAGLUE)$libp

O_SSL=\$(LIB_D)${o}\$(N_SSL)
O_CRYPTO=\$(LIB_D)${o}\$(N_CRYPTO)
O_RSAGLUE=\$(LIB_D)${o}\$(N_RSAGLUE)

SSLOBJ_F=$link{'SSLOBJ'}
CRYPTOOBJ_F=$link{'CRYPTOOBJ'}
RSAGLUEOBJ_F=$link{'RSAGLUEOBJ'}
E_OBJ_F=$link{'E_OBJ'}

INC=-DFLAT_INC -I\$(INC_D) -I\$(INCL_D)
CFLAGS=\$(INC) \$(CFLAG)
LIBS_DEP=\$(O_CRYPTO) \$(O_RSAGLUE) \$(O_SSL)

#############################################
EOF

$rules=<<"EOF";
all: headers lib exe

headers: \$(HEADER) \$(EXHEADER)

lib: \$(LIBS_DEP)

exe: \$(T_EXE) \$(BIN_D)${o}\$(E_EXE)$exep

EOF

#############################################
# We parse in input file and 'store' info for later printing.
open(IN,"<$infile") || die "unable to open $infile:$!\n";
$_=<IN>;
for (;;)
	{
	chop;

	($key,$val)=/^([^=]+)=(.*)/;
	if ($key eq "RELATIVE_DIRECTORY")
		{
		if ($lib ne "")
			{
			$uc=$lib;
			$uc =~ s/^lib(.*)\.a/$1/;
			$uc =~ tr/a-z/A-Z/;
			$lib_nam{$uc}=$uc;
			$lib_obj{$uc}.=$libobj." ";
			}
		last if ($val eq "FINISHED");
		$lib="";
		$libobj="";
		$dir=$val;
		}

	if ($key eq "TEST")
		{ $test.=&var_add($dir,$val); }

	if (($key eq "PROGS") || ($key eq "E_OBJ"))
		{ $e_exe.=&var_add($dir,$val); }

	if ($key eq "LIB")
		{
		$lib=$val;
		$lib =~ s/^.*\/([^\/]+)$/$1/;
		}

	if ($key eq "EXHEADER")
		{ $exheader.=&var_add($dir,$val); }

	if ($key eq "HEADER")
		{ $header.=&var_add($dir,$val); }

	if ($key eq "LIBOBJ")
		{ $libobj=&var_add($dir,$val); }

	if (!($_=<IN>))
		{ $_="RELATIVE_DIRECTORY=FINISHED\n"; }
	}
close(IN);

# Strip of trailing ' '
foreach (keys %lib_obj) { $lib_obj{$_}=&clean_up_ws($lib_obj{$_}); }
$test=&clean_up_ws($test);
$e_exe=&clean_up_ws($e_exe);
$exheader=&clean_up_ws($exheader);
$header=&clean_up_ws($header);

# First we strip the exheaders from the headers list
foreach (split(/\s+/,$exheader)){ $h{$_}=1; }
foreach (split(/\s+/,$header))	{ $h.=$_." " unless $h{$_}; }
chop($h); $header=$h;

$defs.=&do_defs("HEADER",$header,"\$(INCL_D)",".h");
$rules.=&do_copy_rule("\$(INCL_D)",$header,".h");

$defs.=&do_defs("EXHEADER",$exheader,"\$(INC_D)",".h");
$rules.=&do_copy_rule("\$(INC_D)",$exheader,".h");

$defs.=&do_defs("T_OBJ",$test,"\$(OBJ_D)",$obj);
$rules.=&do_compile_rule("\$(OBJ_D)",$test,".c",$obj,"");

$defs.=&do_defs("E_OBJ",$e_exe,"\$(OBJ_D)",$obj);
$rules.=&do_compile_rule("\$(OBJ_D)",$e_exe,".c",$obj,"-DMONOLITH ");

$rules.=&do_lib_rule("SSL");
$rules.=&do_lib_rule("RSAGLUE");
$rules.=&do_lib_rule("CRYPTO");

foreach (values %lib_nam)
	{
	$lib_obj=$lib_obj{$_};
	if (($bn_mulw_obj ne "") && ($_ eq "CRYPTO"))
		{
		$lib_obj =~ s/\S*bn_mulw\S*/\$(BN_MULW_OBJ)/;
		$rules.=&do_asm_rule("\$(BN_MULW_OBJ)","\$(BN_MULW_SRC)")
		}
	$defs.=&do_defs(${_}."OBJ",$lib_obj,"\$(OBJ_D)",$obj);
	$rules.=&do_compile_rule("\$(OBJ_D)",$lib_obj{$_},".c",$obj,"");
	}

$defs.=&do_defs("T_EXE",$test,"\$(TEST_D)",$exep);
foreach (split(/\s+/,$test))
	{
	$t=&bname($_);
	$tt="\$(OBJ_D)${o}$t${obj}";
	$rules.=&do_link_rule("\$(TEST_D)",$_,$tt,$tt,$exep);
	}

$rules.=&do_link_rule("\$(BIN_D)","\$(E_EXE)","\$(E_OBJ)","\$(E_OBJ_F)",$exep);

print $defs;
print "###################################################################\n";
print $rules;

###############################################
# strip off any trailing .[och] and append the relative directory
# also remembering to do nothing if we are in one of the dropped
# directories
sub var_add
	{
	local($dir,$val)=@_;
	local(@a,$_,$ret);

	return("") if $no_idea && $dir =~ /\/idea/;
	return("") if $no_rc2  && $dir =~ /\/rc2/;
	return("") if $no_rc4  && $dir =~ /\/rc4/;
	return("") if $no_des  && $dir =~ /\/des/;
	return("") if $no_md2  && $dir =~ /\/md/;
	return("") if $no_md5  && $dir =~ /\/md/;
	$val =~ s/^\s*(.*)\s*$/$1/;
	@a=split(/\s+/,$val);
	grep(s/\.[och]$//,@a);
	grep($_="$dir/$_",@a);
	@a=grep(!/(^|\/)s_/,@a) if $no_sock;
	$ret=join(' ',@a)." ";
	return($ret);
	}

# change things so that each 'token' is only seperated by one sparc
sub clean_up_ws
	{
	local($w)=@_;

	$w =~ s/^\s*(.*)\s*$/$1/;
	$w =~ s/\s+/ /g;
	return($w);
	}

sub do_defs
	{
	local($var,$files,$location,$postfix)=@_;
	local($_,$ret);
	local(*OUT,$tmp,$t);

	if (($ms) && ($link{$var}))
		{
		($tmp=$var) =~ s/_*OBJ//;
		($tmp=$link{$var}) =~ s/^@//;
	#	print STDERR "writing $tmp\n";
	#	open(OUT,">$tmp") || die "unable to open '$tmp':$!\n";
		}
	$files =~ s/\//$o/g if $o ne '/';
	$ret="$var="; 
	$n=1;
	foreach (split(/ /,$files))
		{
		$_=&bname($_) unless /^\$/;
		if ($n++ == 2)
			{
			$n=0;
			$ret.="\\\n\t";
			}
		if ($_ =~ /BN_MULW/)
			{ $t="$_ "; }
		else	{ $t="$location${o}$_$postfix "; }
		$ret.=$t;
		$t =~ s/\$\(OBJ_D\)/$tmp_dir/;
		$t=$bn_mulw_obj if $t =~ /\$\(BN_MULW_OBJ\)/;
	#	print OUT "$t\n" if ($tmp ne "");
		}
	#close(OUT) if ($tmp ne "");
	chop($ret);
	$ret.="\n\n";
	return($ret);
	}

# return the name with the leading path removed
sub bname
	{
	local($ret)=@_;
	$ret =~ s/^.*[\\\/]([^\\\/]+)$/$1/;
	return($ret);
	}

# do a rule for each file that says 'copy' to new direcory on change
sub do_copy_rule
	{
	local($to,$files,$p)=@_;
	local($ret,$_,$n);
	
	$files =~ s/\//$o/g if $o ne '/';
	foreach (split(/\s+/,$files))
		{
		$n=&bname($_);
		$ret.="$to${o}$n$p: $_$p\n\t\$(CP) $_$p $to${o}$n$p\n\n";
		}
	return($ret);
	}

# do a rule for each file that says 'compile' to new direcory
sub do_compile_rule
	{
	local($to,$files,$in,$out,$ex)=@_;
	local($ret,$_,$n);
	
	$files =~ s/\//$o/g if $o ne '/';
	foreach (split(/\s+/,$files))
		{
		$n=&bname($_);
		$ret.="$to${o}$n$out: $_$in\n\t";
		$ret.="\$(CC) ${ofile}$to${o}$n$out $ex\$(CFLAGS) -c $_$in\n\n";
		}
	return($ret);
	}

sub do_asm_rule
	{
	local($obj,$src)=@_;

	$ret.="$obj: $src\n";
	$ret.="\t\$(ASM) $src\n\n";
	}

#{ $rules.=&do_link_rule("\$(TEST_D)",$_,$_,$obj,"\$(EXE)"); }
# do a rule for each file that says 'compile' to new direcory
sub do_link_rule
	{
	local($to,$n,$file,$lfile,$outp)=@_;
	local($ret,$_);
	
	$file =~ s/\//$o/g if $o ne '/';
	$n=&bname($n);
	$ret.="$to${o}$n$outp: $file \$(LIBS_DEP)\n\t";
	if ($msdos)
		{
		$ret.="link @<<\n \$(E_OBJ_F)\n $to${o}$n$outp\n\n ";
		$ret.="\$(L_LIBS) /SEG:512 /STACK:4096 /EXEPACK;\n<<\n\n";
		}
	else
		{
		$ret.="\$(CC) \$(CFLAGS) ${efile}$to${o}$n$outp \$(LFLAGS) $lfile \$(L_LIBS)\n\n";
		}
	return($ret);
	}

sub do_lib_rule
	{
	local($n)=@_;
	local($ret);
	local($t);

	$ret.="\$(O_$n): \$(${n}OBJ)\n";
	$ret.="\t\$(RM) \$(O_$n)\n";
	if ($ms)
		{
		$ret.="\t\$(MKLIB) $lfile\$(O_$n) @<<\n  \$(${n}OBJ_F);\n<<\n\n";
		}
	else	{ $ret.="\t\$(MKLIB) $lfile\$(O_$n) \$(${n}OBJ_F)\n"; }
	$ret.="\t\$(RANLIB) \$(O_$n)\n" if ($ranlib ne "");
	return($ret);
	}

